#
# Conditional build:
%bcond_with	tests	# perform "make test"
%bcond_without	python2	# CPython 2.x module
%bcond_without	python3	# CPython 3.x module
%bcond_without	bundled # bundled libraries
#
%define		urllib3ver	1.13
%define 	module	requests
Summary:	HTTP library for Python 2
Summary(pl.UTF-8):	Biblioteka HTTP dla Pythona 2
Name:		python-%{module}
Version:	2.11.1
Release:	2
License:	Apache2
Group:		Development/Languages/Python
Source0:	https://pypi.python.org/packages/2e/ad/e627446492cc374c284e82381215dcd9a0a87c4f6e90e9789afefe6da0ad/%{module}-%{version}.tar.gz
# Source0-md5:	ad5f9c47b5c5dfdb28363ad7546b0763
URL:		http://python-requests.org
# find . -name '*.py' -exec sed -i -e 's#requests\.packages\.urllib3#urllib3#g' "{}" ";"
# find . -name '*.py' -exec sed -i -e 's#\.packages\.urllib3#urllib3#g' "{}" ";"
# find . -name '*.py' -exec sed -i -e 's#from \.packages import chardet#import charade as chardet#g' "{}" ";"
# + manual removal from setup.py
Patch0:		system-charade-and-urllib3.patch
Patch1:		system-cert.patch
%if %{with python2}
BuildRequires:	python-modules >= 1:2.6
%if %{without bundled}
BuildRequires:	python-charade
BuildRequires:	python-urllib3 >= %{urllib3ver}
%endif
%{?with_tests:BuildRequires:	python-pytest >= 2.3.4}
%endif
%if %{with python3}
BuildRequires:	python3-modules >= 1:3.2
%if %{without bundled}
BuildRequires:	python3-charade
BuildRequires:	python3-urllib3 >= %{urllib3ver}
%endif
%{?with_tests:BuildRequires:	python3-pytest >= 2.3.4}
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.713
Requires:	ca-certificates
Requires:	python-modules >= 1:2.6
%if %{without bundled}
Requires:	python-charade
Requires:	python-urllib3 >= %{urllib3ver}
%endif
# for python2 only to get SNI working. python3 doesn't need this
Requires:	python-ndg-httpsclient
Requires:	python-pyasn1
Requires:	python-pyOpenSSL
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Requests is a HTTP library, written in Python, for human beings.

Most existing Python modules for sending HTTP requests are extremely
verbose and cumbersome. Python's builtin urllib2 module provides most
of the HTTP capabilities you should need, but the API is thoroughly
broken. It requires an enormous amount of work (even method overrides)
to perform the simplest of tasks. Things shouldn't be this way. Not in
Python.

This package contains Python 2.x module.

%description -l pl.UTF-8
Requests to napisana w Pythonie biblioteka HTTP dla ludzi.

Większość istniejących modułów Pythona do wysyłania żądań HTTP jest
zbyt gadatliwa i nieporęczna. Wbudowany w Pythona moduł urllib2
zapewnia większość wymaganych możliwości HTTP, ale API jest kiepskie -
wymaga dużych nakładów pracy (nawet nadpisań metod) do wykonania
najprostszych zadań. Nie powinno tak być. Nie w Pythonie.

Ten pakiet zawiera moduł dla Pythona 2.x.

%package -n python3-requests
Summary:	HTTP library for Python 3
Summary(pl.UTF-8):	Biblioteka HTTP dla Pythona 3
Group:		Development/Languages/Python
Requires:	ca-certificates
Requires:	python3-modules >= 1:3.2
%if %{without bundled}
Requires:	python3-charade
Requires:	python3-urllib3 >= %{urllib3ver}
%endif

%description -n python3-requests
Requests is a HTTP library, written in Python, for human beings.

Most existing Python modules for sending HTTP requests are extremely
verbose and cumbersome. Python's builtin urllib2 module provides most
of the HTTP capabilities you should need, but the api is thoroughly
broken. It requires an enormous amount of work (even method overrides)
to perform the simplest of tasks. Things shouldn't be this way. Not in
Python.

This package contains Python 3.x module.

%description -n python3-requests -l pl.UTF-8
Requests to napisana w Pythonie biblioteka HTTP dla ludzi.

Większość istniejących modułów Pythona do wysyłania żądań HTTP jest
zbyt gadatliwa i nieporęczna. Wbudowany w Pythona moduł urllib2
zapewnia większość wymaganych możliwości HTTP, ale API jest kiepskie -
wymaga dużych nakładów pracy (nawet nadpisań metod) do wykonania
najprostszych zadań. Nie powinno tak być. Nie w Pythonie.

Ten pakiet zawiera moduł dla Pythona 3.x.

%prep
%setup -q -n %{module}-%{version}
%{!?with_bundled:%patch0 -p1}
%patch1 -p1

%build
%if %{with python2}
%py_build %{?with_tests:test}
%{?with_tests:cp requirements.txt test_requests.py build-2; cd build-2; PYTHONPATH=$(pwd)/lib %{__python} test_requests.py; cd ..}
%endif

%if %{with python3}
%py3_build %{?with_tests:test}
%{?with_tests:cp requirements.txt test_requests.py build-3; cd build-3; PYTHONPATH=$(pwd)/lib %{__python3} test_requests.py; cd ..}
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%py_install
%py_ocomp $RPM_BUILD_ROOT%{py_sitescriptdir}
%py_comp $RPM_BUILD_ROOT%{py_sitescriptdir}
%py_postclean
%endif

%if %{with python3}
%py3_install
%endif

%{__rm} $RPM_BUILD_ROOT{%{py_sitescriptdir},%{py3_sitescriptdir}}/%{module}/cacert.pem
%{!?with_bundled:%{__rm} -r $RPM_BUILD_ROOT{%{py_sitescriptdir},%{py3_sitescriptdir}}/%{module}/packages}

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc HISTORY.rst README.rst
%{py_sitescriptdir}/%{module}
%{py_sitescriptdir}/%{module}-%{version}-py*.egg-info
%endif

%if %{with python3}
%files -n python3-requests
%defattr(644,root,root,755)
%doc HISTORY.rst README.rst
%{py3_sitescriptdir}/%{module}
%{py3_sitescriptdir}/%{module}-%{version}-py*.egg-info
%endif
%changelog
* Wed Dec 28 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-requests.git;a=log;h=master

* Wed Dec 28 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> a8529d2
- python 3.6
- release 2 (by relup.sh)

* Mon Aug 22 2016 Marcin Krol <hawk@tld-linux.org> c8af30d
- updated to 2.11.1

* Tue Jan 26 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 2d60646
- urllib 1.13

* Tue Jan 26 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 86b1434
- up to 2.9.1

* Fri Dec 04 2015 Jacek Konieczny <j.konieczny@eggsoft.pl> ff50b3c
- release 2 (by relup.sh)

* Thu Dec 03 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 7d9f4eb
- up to 2.8.1

* Thu Dec 03 2015 Jacek Konieczny <jajcus@jajcus.net> b4dcbe0
- fix py_build/py_install usage

* Sun Nov 29 2015 Jacek Konieczny <jajcus@jajcus.net> 8f95d36
- BR: rpmbuild(macros) >= 1.710

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 85ce507
- release 3 (by relup.sh)

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> fa6a20a
- automatic change: use py_build/py_install macros

* Mon Sep 14 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 77af0a0
- release 2 (by relup.sh)

* Sat May 16 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> c29b18e
- up to 2.7.0; switch back to bundled (it's hard to track incompatibilities)

* Sat Mar 07 2015 Jakub Bogusz <qboosh@pld-linux.org> b83f711
- pytest version

* Fri Mar 06 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> d49507c
- up to 2.5.3

* Tue Dec 16 2014 Jakub Bogusz <qboosh@pld-linux.org> ae79718
- seems to work with system urllib3 1.10

* Thu Dec 04 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> aa92fbe
- tests don't work offline, disable tests then

* Thu Dec 04 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 762b662
- offline tests

* Thu Dec 04 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 40323c1
- more testing

* Thu Dec 04 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 27c2baf
- up to 2.5.0; bundle libraries for now as requests use newer lib than python provides (from urllib3.exceptions import ResponseError -> importError: cannot import name ResponseError

* Mon Nov 10 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> e7d50ac
- rel 2; python2 module requires some externals to get better SSL support (SNI for example)

